@echo off

echo Compiling checker
g++ -O2 -I ..\..\..\lib -o check.exe check.cpp

echo Compiling validator
g++ -O2 -I ..\..\..\lib -std=c++11 -o validate.exe validate.cpp
g++ -O2 -I ..\..\..\lib -std=c++11 -o validate_subtask1.exe validate_subtask1.cpp
g++ -O2 -I ..\..\..\lib -std=c++11 -o validate_subtask2.exe validate_subtask2.cpp
g++ -O2 -I ..\..\..\lib -std=c++11 -o validate_subtask3.exe validate_subtask3.cpp

echo Generating tests
if exist preliminary rd /s /q preliminary
if exist tests rd /s /q tests
pushd src
python gen.py
popd

echo Compiling main solution
pushd main
g++ -O2  -Wall -Wextra -Wconversion -Werror -std=c++11 -o ..\calc_nb.exe calc_nb.cpp
popd

echo Generating answers
for %%i in (preliminary, tests\subtask1, tests\subtask2, tests\subtask3, tests\subtask4) do (
    for %%j in (%%i\??) do (
        echo Copying input for test %%j
        copy %%j calc.in > nul

        echo Validating test %%j
        validate.exe < calc.in
        if errorlevel 1 (
            echo Validator rejects test %%j
            goto end
        )
        if [%%i]==[tests\subtask1] (
            validate_subtask1.exe < calc.in
            if errorlevel 1 (
                echo Validator rejects test %%j
                goto end
            )
        )
        if [%%i]==[tests\subtask2] (
            validate_subtask2.exe < calc.in
            if errorlevel 1 (
                echo Validator rejects test %%j
                goto end
            )
        )
        if [%%i]==[tests\subtask3] (
            validate_subtask3.exe < calc.in
            if errorlevel 1 (
                echo Validator rejects test %%j
                goto end
            )
        )

        echo Validator accepts test %%j

        echo Running solution on test %%j
        calc_nb.exe
        if errorlevel 1 (
            echo Solution failed on test %%j
            goto end
        )

        echo Running checker on test %%j        
        check.exe %%j calc.out calc.out
        if errorlevel 1 (
            echo Checker rejects main solution output on test %%j
            goto end
        )

        echo Saving answer for test %%j
        copy calc.out %%j.a > nul
    )
)


:end