import java.io.*;
import java.util.Random;
import java.util.Scanner;

public class Stress {
    final static int N = 200_000;
    final static int MAX_X = 100;

    final static Random rnd = new Random(3);

    static long readAns() throws FileNotFoundException {
        Scanner in = new Scanner(new File("power.out"));
        long res = in.nextLong();
        in.close();
        return res;
    }

    static void gen() throws FileNotFoundException {
        PrintWriter out = new PrintWriter("power.in");
        int n = N;
        int k = rnd.nextInt(n - 1) + 1;
        out.println(n + " " + k);
        for (int i = 0; i < n; i++) {
            int x = rnd.nextInt(MAX_X) + 1;
            int y = rnd.nextInt(MAX_X) + 1;
            out.println(x + " " + y);
        }
        out.close();
    }

    static volatile int done;

    public static void main(String[] args) throws IOException {
        Thread printer = new Thread(new Runnable() {
            @Override
            public void run() {
                while (!Thread.interrupted()) {
                    System.out.println("========= " + done + " =======");
                    try {
                        Thread.sleep(1000);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                }
            }
        });
        printer.start();
        while (true) {
            gen();
            power_ak.main(null);
            long ans1 = readAns();
            power_ak_treeset.main(null);
            long ans2 = readAns();
            if (ans1 != ans2) {
                printer.interrupt();
                System.err.println("ERR: " + ans1 + " != " + ans2);
                System.exit(0);
            }
            done++;
        }

    }
}
