#include "testlib.h"
#include <vector>

using namespace std;

int const MAX_N = 200 * 1000;
int const MAX_M = 200 * 1000;

vector<int> tree[MAX_N];
int height[MAX_N];

int calculateHeight(int u) {
  height[u] = 0;
  for (int v : tree[u]) {
    height[u] = max(height[u], 1 + calculateHeight(v));
  }
  return height[u];
}

int main(int argc, char **argv) {
  registerValidation(argc, argv);
  int n = inf.readInt(2, MAX_N);
  inf.readEoln();

  for (int i = 1; i < n; i++) {
    int parent = inf.readInt(1, i) - 1;
    tree[parent].push_back(i);
    ensuref(parent == i - 1, "In subtask 3 parent[%d] should be %d, but was %d", i + 1, i, parent + 1);
    if (i + 1 < n) {
      inf.readSpace();
    } else {
      inf.readEoln();
    }
  }

  calculateHeight(0);

  int m = inf.readInt(1, MAX_M);
  inf.readEoln();
  
  for (int i = 0; i < m; i++) {
    int u = inf.readInt(1, n - 1) - 1;
    inf.readSpace();
    int k = inf.readInt(1, n - 1);
    inf.readEoln();

    ensuref(height[u] >= k, "Vertex %d does not have an ancestor of order %d", u + 1, k);
  }
  inf.readEof();
}